
/* ***************************************************
	FILE:  Gui.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**
	Runs logo with an AWT-based console
*/
public class Gui
{
	/**
		No instantiation of this class
	*/
	private Gui() {}
	
	public static JFrame SPLASH_SCREEN = null;
	public static long SPLASH_APPEAR_TIME;
	public static long SPLASH_DISAPPEAR_TIME;
	
	
	public static void main( String[] args ) {
		
		try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch(Exception e) {
      System.out.println("Error setting native LAF: " + e);
    }
//%%		try {
//%%			System.out.println(".main()"+"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-89");
//%%	//:explicit plaf == metal
//%%			//final String laf = "javax.swing.plaf.mac.MacLookAndFeel";
//%%			final String laf = "com.sun.java.swing.plaf.mac.MacLookAndFeel";
//%%			try {
//%%				System.out.println("trying to set the laf to: " + laf+"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-94");
//%%				javax.swing.UIManager.setLookAndFeel( laf );
//%%			}
//%%			catch( Throwable t ) {
//%%				t.printStackTrace();
//%%				System.out.println("Could not set LookAndFeel to " + laf + ", caught throwable: " + t+"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-99");
//%%			}
//%%			finally {
//%%				System.out.println("finally clause for attempt to set LookAndFeel."+"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-102");
//%%			}
//%%		}
//%%		catch( ExceptionInInitializerError e ) {
//%%			e.printStackTrace();
//%%			System.out.println("ExceptionInInitializerError " + e +"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-107");
//%%			
//%%			e.getException().printStackTrace();
//%%			System.out.println("  nested exception in the ExceptionInInitializerError is " + e.getException() +"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-110");
//%%		}
//%%		catch( Throwable t ) {
//%%			t.printStackTrace();
//%%			System.out.println("t : " + t +"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-114");
//%%		}
//%%		finally {
//%%			System.out.println(" DONE WITH CALL LAF setting"+"<:|:>"+"virtuoso.logo.app.Gui.java.ux:TL-117");
//%%		}
		
		final String os = ""+System.getProperty("os.name");
		if( !os.equals( "Mac OS") ) {
			SPLASH_SCREEN = new JFrame("");
			SPLASH_SCREEN.setUndecorated(true);
			ImageIcon icon = new ImageIcon( UIAid.SPLASH_IMAGE );
			JLabel label = new JLabel( icon );
			SPLASH_SCREEN.getContentPane().add( label );
			SPLASH_SCREEN.pack();
			SPLASH_SCREEN.setLocationRelativeTo(null);
			SPLASH_SCREEN.show();
			SPLASH_APPEAR_TIME = System.currentTimeMillis();
			SPLASH_DISAPPEAR_TIME = SPLASH_APPEAR_TIME + 4000;
		}
		
		
		
		
		
		try {
			String[] realArgs = new String[ args.length +5 ];
			realArgs[0] = "-std";
			realArgs[1] = "-p";
			realArgs[2] = "virtuoso.logo.lib.TurtlePrimitives";
			realArgs[3] = "-c";
			realArgs[4] = "virtuoso.logo.app.GuiConsole";
			System.arraycopy( args, 0, realArgs, 5, args.length );
			
			Run.main(realArgs);
		}
		catch( Throwable t ) {
			t.printStackTrace();
			//Frame f = new Frame();
			//f.setTitle( "mrj app keeper from going awayer" );
			//f.show();
		}
	
	}
	
}