
/* ***************************************************
	FILE:  GuiConsoleKeyListener.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/*
	Mon Jul 11 23:31:26 CDT 2005,
		pulled from GuiConsole{ame;Wind
*/

public class GuiConsoleKeyListener
implements KeyListener
{

	public static boolean READ_CHAR_MODE = false;
	private static boolean WAS_IN_CHAR_MODE = false;

	public GuiConsoleKeyListener( GuiConsolePanel gcpanel ) {
		_gcpanel = gcpanel;
	}
	private GuiConsolePanel _gcpanel;
	// =======================================

	public void keyTyped( KeyEvent event) {
		char c = event.getKeyChar();
		if (c == '\n' || c == '\r') {
			event.consume();
		}
	}
	public void keyPressed( KeyEvent event) {
		final char c = event.getKeyChar();
		
		
		if( event.getKeyCode() == KeyEvent.VK_ENTER
		||(READ_CHAR_MODE&&_gcpanel._entryArea.getText().length() < 1 && ((int)c!=0&&(int)c!=65535) )
		){
			if( READ_CHAR_MODE ) {
				_gcpanel._entryArea.setText( ""+c );
				READ_CHAR_MODE = false;
				WAS_IN_CHAR_MODE = true;
			}
			if( _gcpanel._entryArea.getText().length() > 0 ) {
				_gcpanel._guiConsole.pushBuffer(_gcpanel._entryArea.getText());
				_gcpanel._entryArea.setText("");
				_gcpanel._historyPos = -1;
				event.consume();
			}
		} else if( event.getKeyCode() == KeyEvent.VK_UP ) {
			if (_gcpanel._historyPos < _gcpanel._history.size() - 1) {
				_gcpanel._historyPos++;
				String str = (String)(_gcpanel._history.elementAt(_gcpanel._historyPos));
				int pos = str.length();
				_gcpanel._entryArea.setText(str);
				_gcpanel._entryArea.setCaretPosition(pos);
				_gcpanel._entryArea.select(pos, pos);
			}
			event.consume();
		} else if( event.getKeyCode() == KeyEvent.VK_DOWN ) {
			if (_gcpanel._historyPos > -1) {
				_gcpanel._historyPos--;
				if (_gcpanel._historyPos > -1) {
					String str = (String)(_gcpanel._history.elementAt(_gcpanel._historyPos));
					int pos = str.length();
					_gcpanel._entryArea.setText(str);
					_gcpanel._entryArea.setCaretPosition(pos);
					_gcpanel._entryArea.select(pos, pos);
				} else {
					_gcpanel._entryArea.setText("");
				}
			}
			event.consume();
		}
	}
	public void keyReleased(KeyEvent event){
		if( WAS_IN_CHAR_MODE ) {
				_gcpanel._entryArea.setText("");
				WAS_IN_CHAR_MODE=false;
				event.consume();
		}
	}
}