
/* ***************************************************
	FILE:  GuiConsoleLayout.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**

*/
public class GuiConsoleLayout
{
	public static final JPanel makeLayoutComponent( 
	 final JComponent goButton
	 , final JComponent stopButton
	 , final JComponent sliderHolder
	 , final JComponent t
	 , final JComponent gc
	 , final JComponent p
	) {
		return makeLayout2( goButton, stopButton, sliderHolder, t, gc, p );
	}
	public static final JPanel makeLayout1( 
		final JComponent goButton
		, final JComponent stopButton
		, final JComponent sliderHolder
		, final JComponent turtlePanel
		, final JComponent gcpanel
		, final JComponent proceduresPanel
	) {
		JPanel p = new JPanel();
		p.setLayout( new GridBagLayout() );
		GridBagConstraints gbc = new GridBagConstraints();
	
		JPanel buttons = new JPanel();
		//buttons.setLayout( new BorderLayout());
		buttons.add( goButton, BorderLayout.EAST );
		JPanel spacer = new JPanel();
		spacer.setSize( 40, 2 );
		spacer.setPreferredSize( new Dimension( 40, 2 ) );
		spacer.setMaximumSize( new Dimension( 40, 2 ) );
		buttons.add( spacer );
		buttons.add( stopButton, BorderLayout.WEST );
		//buttons.setPreferredSize( new Dimension( 100, 24 ) );
		//buttons.setMaximumSize( new Dimension( 100, 24 ) );
		buttons.getInsets().top = 0;
		buttons.getInsets().bottom = 0;
		//JPanel b2 = new JPanel();
		//b2.setLayout( new BorderLayout() );
		//b2.add( buttons, BorderLayout.NORTH );
		//buttons = b2;
		
		
		JPanel buttonsCombo = new JPanel();
		buttonsCombo.setLayout( new BorderLayout() );
		buttonsCombo.add( buttons, BorderLayout.NORTH );
		buttonsCombo.add( sliderHolder, BorderLayout.SOUTH );
		
		UIAid.borderize( gcpanel, AppData.COMMAND_CENTER_TITLE );
		
		JPanel borderForTurtlePanel = new JPanel();
		borderForTurtlePanel.setLayout( new BorderLayout() );
		borderForTurtlePanel.add( turtlePanel, BorderLayout.CENTER );
		//borderForTurtlePanel.add( buttons, BorderLayout.SOUTH );
		UIAid.borderize( borderForTurtlePanel, AppData.TURTLE_GRAPHICS_TITLE );
		JPanel b2 = new JPanel();
		b2.setLayout( new BorderLayout() );
		b2.add( borderForTurtlePanel, BorderLayout.NORTH );
		b2.add( new JPanel(), BorderLayout.CENTER ); // TO USE UP SPACE
		b2.add( buttonsCombo, BorderLayout.SOUTH );
		
		
		// ==================================
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.fill = GridBagConstraints.VERTICAL;
		gbc.anchor = GridBagConstraints.NORTH | GridBagConstraints.CENTER;
		p.add( b2, gbc );
		// ==================================
		
		
		JPanel consoleHolder = new JPanel();
		consoleHolder.setLayout( new BorderLayout() );
		//consoleHolder.add( buttons, BorderLayout.EAST );
		consoleHolder.add( gcpanel, BorderLayout.CENTER );
		// ==================================
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 2;
		gbc.gridheight = 1;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.weighty = 1.0;
		p.add( consoleHolder, gbc );
		// ==================================
		
		
		
		
		JPanel proceduresPanelHolder = new JPanel();
		UIAid.borderize( proceduresPanelHolder, AppData.PROCEDURES_TITLE );
		proceduresPanelHolder.setLayout( new BorderLayout() );
		proceduresPanelHolder.add( proceduresPanel, BorderLayout.CENTER );
		
		// ==================================
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor = GridBagConstraints.CENTER | GridBagConstraints.NORTH;
		gbc.weightx = 1.0;
		gbc.weighty = 0.8;
		p.add( proceduresPanelHolder, gbc );
		// ==================================
		return p;
	}
	
	public static final JPanel makeLayout2( 
		final JComponent goButton
		, final JComponent stopButton
		, final JComponent sliderHolder
		, final JComponent turtlePanel
		, final JComponent gcpanel
		, final JComponent proceduresPanel
	) {
		
		JPanel p = new JPanel();
		p.setLayout( new GridBagLayout() );
		GridBagConstraints gbc = new GridBagConstraints();
	
		JPanel buttons = new JPanel();
		buttons.add( goButton, BorderLayout.EAST );
		JPanel spacer = new JPanel();
		spacer.setSize( 40, 2 );
		spacer.setPreferredSize( new Dimension( 40, 2 ) );
		spacer.setMaximumSize( new Dimension( 40, 2 ) );
		buttons.add( spacer );
		buttons.add( stopButton, BorderLayout.WEST );
		buttons.getInsets().top = 0;
		buttons.getInsets().bottom = 0;
		
		JPanel buttonsCombo = new JPanel();
		buttonsCombo.setLayout( new BorderLayout() );
		buttonsCombo.add( buttons, BorderLayout.NORTH );
		buttonsCombo.add( sliderHolder, BorderLayout.SOUTH );
		
		
		JPanel borderForTurtlePanel = new JPanel();
		borderForTurtlePanel.setLayout( new BorderLayout() );
		borderForTurtlePanel.add( turtlePanel, BorderLayout.CENTER );
		//borderForTurtlePanel.add( buttons, BorderLayout.SOUTH );
		JPanel b2 = new JPanel();
		b2.setLayout( new BorderLayout() );
		b2.add( borderForTurtlePanel, BorderLayout.NORTH );
		
		JPanel consoleHolder = new JPanel();
		consoleHolder.setLayout( new BorderLayout() );
		consoleHolder.add( gcpanel, BorderLayout.CENTER );
		//b2.add( new JPanel(), BorderLayout.CENTER ); // TO USE UP SPACE
		b2.add( consoleHolder, BorderLayout.CENTER ); // TO USE UP SPACE
		b2.add( buttonsCombo, BorderLayout.SOUTH );
		
		
		
		// ==================================
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.fill = GridBagConstraints.VERTICAL;
		gbc.anchor = GridBagConstraints.NORTH | GridBagConstraints.CENTER;
		p.add( b2, gbc );
		// ==================================
		
		JPanel proceduresPanelHolder = new JPanel();
		proceduresPanelHolder.setLayout( new BorderLayout() );
		proceduresPanelHolder.add( proceduresPanel, BorderLayout.CENTER );
		
		// ==================================
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.anchor = GridBagConstraints.CENTER | GridBagConstraints.NORTH;
		gbc.weightx = 1.0;
		gbc.weighty = 0.8;
		p.add( proceduresPanelHolder, gbc );
		// ==================================
		UIAid.borderize( gcpanel, AppData.COMMAND_CENTER_TITLE );
		UIAid.borderize( borderForTurtlePanel, AppData.TURTLE_GRAPHICS_TITLE );
		UIAid.borderize( proceduresPanelHolder, AppData.PROCEDURES_TITLE );
		return p;
	}
		
	static class JSplitPanePanelHelp extends JPanel
	{
		private String _type = "";
		public JSplitPanePanelHelp( final String type ) {
			_type = type;
			setLayout( new BorderLayout() );
		}
		public Dimension getPreferredSize() {
			System.out.println(" here "+"<:|:>"+"virtuoso.logo.app.GuiConsoleLayout.java.ux:TL-265");
			
			final JComponent parent = (JComponent)getParent();
			if( parent instanceof  JSplitPane ) {
				System.out.println("parent is JSplitPane "+"<:|:>"+"virtuoso.logo.app.GuiConsoleLayout.java.ux:TL-269");
				
				int w = parent.getWidth();
				
				int h = 200;//, ((JSplitPane)parent).getDividerLocation() );
				
				
				return new Dimension( w, h );
			}
			else {
				System.out.println("parent is not JSplitPane"+"<:|:>"+"virtuoso.logo.app.GuiConsoleLayout.java.ux:TL-279");
				return super.getPreferredSize();
			}
		}
	}
	

}