
/* ***************************************************
	FILE:  GuiConsoleMenuBar.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**
	pulled from GuiConsoleWind on Sun Jul 17 17:52:25 CDT 2005
	
*/
public class GuiConsoleMenuBar extends JMenuBar
{

	JMenuItem _cutItem;
	JMenuItem _pasteItem;
	JMenuItem _clearItem;
	
	public JMenuItem getSaveMenu() { return _saveMenu; }
	private JMenuItem _saveMenu;

	private int MASK = java.awt.Event.CTRL_MASK;

	public GuiConsoleMenuBar( final GuiConsole guiConsole, final ActionListener actionListener, GuiConsoleFocusListener gcfl ) {
		JMenuBar mb = this;
		JMenu m;
		JMenuItem mi;
		// ******************************
		m = new JMenu("File");
		mi = new JMenuItem("New");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand( MenuCommands.NEW );
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, MASK));
		m.add(mi);
		
		mi = new JMenuItem("Open...");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand( MenuCommands.OPEN );
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, MASK));
		m.add(mi);
		
		_saveMenu = new JMenuItem( "Save" );
		mi = _saveMenu;
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand( MenuCommands.SAVE );
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, MASK));
		m.add(mi);
		
		mi = new JMenuItem("Save As...");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand( MenuCommands.SAVE_AS );
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, MASK | java.awt.Event.SHIFT_MASK));
		m.add(mi);
		
		m.addSeparator();
		
		mi = new JMenuItem("Close Procedures");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand( MenuCommands.CLOSE );
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, MASK | java.awt.Event.SHIFT_MASK));
		m.add(mi);
		
		mi = new JMenuItem("Load Procedures...");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand(MenuCommands.LOAD_PROCEDURES);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, MASK | java.awt.Event.SHIFT_MASK));
		m.add(mi);
		
		m.addSeparator();
		mi = new JMenuItem("Save Graphics...");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand( MenuCommands.SAVE_AS_IMAGE );
		m.add(mi);
		
		mi = new JMenuItem("Open Graphics...");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand(MenuCommands.OPEN_GRAPHICS);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_G, MASK | java.awt.Event.SHIFT_MASK));
		m.add(mi);
		m.addSeparator();
		
		
//		mi = new JMenuItem("Save Procedures...");
//		mi.addActionListener(guiConsole._menuActor);
//		mi.setActionCommand(MenuCommands.SAVE_PROCEDURES);
//		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, MASK));
//		m.add(mi);
		
		m.addSeparator();
		mi = new JMenuItem("Quit");
		mi.addActionListener(actionListener);
		mi.setActionCommand( MenuCommands.QUIT );
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, MASK));
		m.add(mi);
		
		
		
//		m.addSeparator();
//		mi = new JMenuItem("print focus owner");
//		mi.addActionListener(new ActionListener() { public void actionPerformed( ActionEvent e ) { 
//			System.out.println("focus owner: " + guiConsole.getJFrame().getFocusOwner() +"<:|:>"+"virtuoso.logo.app.GuiConsoleMenuBar.java.ux:TL-159");
//		
//		}} );
//		
//		m.add(mi);
		
		mb.add(m);
		
		// ******************************
		m = new JMenu("Edit");
		mi = new JMenuItem("Undo");
		mi.setEnabled(false);
		mi.addActionListener(actionListener);
		mi.setActionCommand(MenuCommands.UNDO);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, MASK));
		m.add(mi);
		m.addSeparator();
		_cutItem = new JMenuItem("Cut");
		_cutItem.addActionListener(actionListener);
		_cutItem.setActionCommand(MenuCommands.CUT);
		_cutItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, MASK));
		m.add(_cutItem);
		mi = new JMenuItem("Copy");
		mi.addActionListener(actionListener);
		mi.setActionCommand(MenuCommands.COPY);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, MASK));
		m.add(mi);
		_pasteItem = new JMenuItem("Paste");
		_pasteItem.addActionListener(actionListener);
		_pasteItem.setActionCommand(MenuCommands.PASTE);
		_pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, MASK));
		m.add(_pasteItem);
		_clearItem = new JMenuItem("Clear");
		_clearItem.addActionListener(actionListener);
		_clearItem.setActionCommand(MenuCommands.CLEAR);
		_clearItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B, MASK));
		m.add(_clearItem);
		m.addSeparator();
		mi = new JMenuItem("Clear History");
		mi.addActionListener(actionListener);
		mi.setActionCommand(MenuCommands.CLEAR_HISTORY);
		m.add(mi);
		mb.add(m);
		// ******************************
		/*
		m = new JMenu("Environment");
		mi = new JMenuItem("Reset Environment");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand(MenuCommands.RESET_ENV);
		m.add(mi);
		m.addSeparator();
		mi = new JMenuItem( "Interrupt", new ImageIcon( "stop-small.jpg" ));
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand(MenuCommands.INTERRUPT);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_PERIOD, MASK));
		m.add(mi);
		mi = new JMenuItem("Pause");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand(MenuCommands.PAUSE);
		m.add(mi);
		mb.add(m);
		*/
		
//: LOGO FILES THAT ARE PLACED INTO THE XM ZIP FILE, get to be loaded into their own menus
		new CustomMenuLoader().makeExtensionMenus( mb, guiConsole );
		
		
		m = new JMenu("Tutorial");
		mi = new JMenuItem("Show Tutorial");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand(MenuCommands.SHOW_TUTORIAL);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T, MASK));
		m.add(mi);
		mb.add(m);
		
		gcfl.setMenuItems( _cutItem, _clearItem, _pasteItem );
	}
	

}