
/* ***************************************************
	FILE:  GuiEditorMenuBar.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**
	Mon Jul 18 01:28:30 CDT 2005
		pulled from the GuiEditorWind
*/
class GuiEditorMenuBar extends JMenuBar
{
	public GuiEditorMenuBar( final GuiConsole guiConsole, final ActionListener actionListener ) {
		JMenuBar mb = this;
		JMenu m;
		JMenuItem mi;
		
		m = new JMenu("File");
		mi = new JMenuItem("New");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand("NEW ");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, java.awt.Event.CTRL_MASK));
		m.add(mi);
		mi = new JMenuItem("Open...");
		mi.addActionListener(guiConsole._menuActor);
		mi.setActionCommand("OPEN");
		m.add(mi);
		m.addSeparator();
		mi = new JMenuItem("Execute without closing");
		mi.addActionListener(actionListener);
		mi.setActionCommand("ACCP");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, java.awt.Event.META_MASK));
		m.add(mi);
		mi = new JMenuItem("Close And Execute");
		mi.addActionListener(actionListener);
		mi.setActionCommand("CLAC");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, java.awt.Event.META_MASK));
		m.add(mi);
		mi = new JMenuItem("Close And Discard");
		mi.addActionListener(actionListener);
		mi.setActionCommand("CLDS");
		m.add(mi);
		mi = new JMenuItem("Save As...");
		mi.addActionListener(actionListener);
		mi.setActionCommand("SAVE");
		m.add(mi);
		m.addSeparator();
		mi = new JMenuItem("Quit");
		mi.addActionListener(actionListener);
		mi.setActionCommand("QUIT");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, java.awt.Event.META_MASK));
		m.add(mi);
		mb.add(m);
		
		m = new JMenu("Edit");
		mi = new JMenuItem("Undo");
		mi.setEnabled(false);
		mi.addActionListener(actionListener);
		mi.setActionCommand("UNDO");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, java.awt.Event.META_MASK));
		m.add(mi);
		m.addSeparator();
		mi = new JMenuItem("Cut");
		mi.addActionListener(actionListener);
		mi.setActionCommand("CUT ");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, java.awt.Event.META_MASK));
		m.add(mi);
		mi = new JMenuItem("Copy");
		mi.addActionListener(actionListener);
		mi.setActionCommand("COPY");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, java.awt.Event.META_MASK));
		m.add(mi);
		mi = new JMenuItem("Paste");
		mi.addActionListener(actionListener);
		mi.setActionCommand("PAST");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, java.awt.Event.META_MASK));
		m.add(mi);
		mi = new JMenuItem("Clear");
		mi.addActionListener(actionListener);
		mi.setActionCommand("CLER");
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B, java.awt.Event.META_MASK));
		m.add(mi);
		mb.add(m);
	}
	
}