
/* ***************************************************
	FILE:  JLongMenu.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**
	A subclass of JMenu which adds a simple heuristic for ensuring that the popup menu gets placed onscreen.
	
	IMPORTANT: This only supports FIXED menus, that get only additions of JMenuItems!
	If you like to remove items from the menu in run-time, or add other types of components, it needs to be developed! (but this is good for most of the cases).
	
	@author Moti Pinhassi, 10-Apr-2002.
	Location change is based on Sun's workaround for bug 4236438.
*/
public class JLongMenu extends JMenu
{
    JLongMenu moreMenu = null;
    int maxItems = 15; // default
    
    int HACK_CLOSEST_ALLOWED_TO_TOP = 50;
    
    int MAX_HEIGHT = 600;
    
    public JLongMenu(String label) {
        super(label);
        JMenuItem getHeightMenu = new JMenuItem("Temporary");
        int menuItemHeight = getHeightMenu.getPreferredSize().height;
        int screenHeight = Toolkit.getDefaultToolkit().getScreenSize().height;
        
        screenHeight -= 100; // quick hack to account for menubar
        
        // =======================
        // get graphics environment on non os9 computers
        //try {
        //		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        //		GraphicsDevice gd = ge.getDefaultScreenDevice();
        		//System.out.println( "GraphicsDevice is:" + gd + "gd.hashcode:"+gd.hashCode());	
        //}catch(Exception e ) {
        	// no big deal
        //}
        // =======================
        
        
        maxItems = screenHeight / menuItemHeight - 3;
        
        maxItems = MAX_HEIGHT / menuItemHeight - 3;
        
        // leave one for the "more" menu and one for the windows task bar and one for macos menubar
    }
 
    // We override this method just so we can call our version of
    // getPopupMenuOrigin. It is pretty much just a copy of JMenu.setPopupMenuVisible


		public void setPopupMenuVisible(boolean b) {
			
			
			//final boolean topLevel = !(getParent() instanceof virtuoso.logo.app.JLongMenu);
    	
        if (!isEnabled())
            return;
        boolean isVisible = isPopupMenuVisible();
        if (b != isVisible) {
            // We can't call ensurePopupMenuCreated() since it is private so
            // we call a method that calls it. (Sneaky huh?).
            isPopupMenuVisible();
            // Set location of popupMenu (pulldown or pullright)
            //  Perhaps this should be dictated by L&F
            if ((b==true) && isShowing()) {
                Point p = getPopupMenuOrigin();
								if( isTopLevelMenu() ) {
									p.x = p.x - getBounds().width;
								}
                //System.out.println("Showing menu at point:"+p);
                getPopupMenu().show(this, p.x, p.y);
            } else {
                getPopupMenu().setVisible(false);
            }
        }
    }
 
    /**
     * Compute the origin for the JMenu's popup menu.
     *
     * @returns a Point in the coordinate space of the menu instance
     * which should be used as the origin of the JMenu's popup menu.
     */
    protected Point getPopupMenuOrigin() {
        int x = 0;
        int y = 0;
        JPopupMenu pm = getPopupMenu();
        // Figure out the sizes needed to caclulate the menu position
        Dimension screenSize =Toolkit.getDefaultToolkit().getScreenSize();
        Dimension s = getSize();
        Dimension popupMenuSize = pm.getSize();
        // For the first time the menu is popped up, the size has not yet been initiated
        if (popupMenuSize.width==0) {
            popupMenuSize = pm.getPreferredSize();

        }
        Point locationOnScreen = getLocationOnScreen();
 
        Container parent = getParent();
        //if (parent instanceof JPopupMenu) {
            // We are a submenu (pull-right)
 
            // if( SwingUtilities.isLeftToRight(this) ) { // Package private.
            //if( getComponentOrientation() == ComponentOrientation.LEFT_TO_RIGHT ) {
                // First determine x:
                if (locationOnScreen.x+s.width + popupMenuSize.width < screenSize.width) {
                    x = s.width;         // Prefer placement to the right
                } else {
                    x = 0-popupMenuSize.width;  // Otherwise place to the left
                }
            /*} else {
                // First determine x:
                if (locationOnScreen.x < popupMenuSize.width) {
                    x = s.width;         // Prefer placement to the right
                } else {
                    x = 0-popupMenuSize.width;  // Otherwise place to the left
                }
            }*/
        	//System.out.println("\n\n");
        	//System.out.println( "The position: " + locationOnScreen );
        	//System.out.println( "The popupMenuSize  : " + popupMenuSize );
        	//System.out.println( "The screenSize: " + screenSize );
        	//System.out.println( "The s       : " + s );
            // Then the y:
            //if (locationOnScreen.y+popupMenuSize.height < screenSize.height ) {
          //  	System.out.println( "case 1: if (position.y+pmSize.height < screenSize.height ) {");
                y = s.height;   // Prefer dropping down
            //} else {
            //	System.out.println( "case 2");
            //    y = s.height-popupMenuSize.height;  // Otherwise drop 'up'
            //    if(y < 0-locationOnScreen.y)
            //        y = 0-locationOnScreen.y;
            //}
            if( y < HACK_CLOSEST_ALLOWED_TO_TOP ) {
            	//y = HACK_CLOSEST_ALLOWED_TO_TOP;
            }
        //}
       // } else {
       /*
            // We are a toplevel menu (pull-down)
 
            // if( SwingUtilities.isLeftToRight(this) ) { // Package private.
            if( getComponentOrientation() == ComponentOrientation.LEFT_TO_RIGHT ) {
                // First determine the x:
                if (position.x+pmSize.width < screenSize.width) {
                    x = 0;                     // Prefer extending to right
                } else {
                    x = s.width-pmSize.width;  // Otherwise extend to left
                }
            } else {
                // First determine the x:
                if (position.x+s.width < pmSize.width) {
                    x = 0;                     // Prefer extending to right
                } else {
                    x = s.width-pmSize.width;  // Otherwise extend to left
                }
            }
            // Then the y:
            if (position.y+s.height+pmSize.height < screenSize.height) {
                y = s.height;          // Prefer dropping down
            } else {
                y = 0-pmSize.height;   // Otherwise drop 'up'
                if(y < 0-position.y)
                    y = 0-position.y;
            }
        }
        */
        return new Point(x,y);
    }
 
    public JMenuItem add (JMenuItem item) {
        if(moreMenu != null) {// We already have a more menu - add it there.

            return moreMenu.add(item);
        }
        if(getItemCount() < maxItems) {// We don't go over the limit - just add it.


            return super.add(item);
        }

        // If we reached here, we reached the limit and we don't have a more menu.
        // Lets create it and add the item there.
        moreMenu = new JLongMenu("More...");

        super.add (moreMenu);
        return moreMenu.add(item);
    }
}