
/* ***************************************************
	FILE:  LogoAid.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
import java.util.zip.*;
import java.io.*;
import java.net.*;
import java.awt.image.*;
import javax.imageio.ImageIO;
import java.util.stream.Collectors;

/**

	
*/
public class LogoAid
{
	public static final Font MONO_SPACED_FONT = Font.decode("Monospaced");
	
	public static final File promptUserForSaveFile( final GuiConsole guiConsole ) {
		final FileDialog fileDialog = new FileDialog(guiConsole.getJFrame(), "Save Edits", FileDialog.SAVE);
		fileDialog.show();
		fileDialog.toFront();
		fileDialog.setLocationRelativeTo(guiConsole.getJFrame());
		String name = fileDialog.getFile();
		if( name == null) {
			return null;
		}
		final File file = new File(fileDialog.getDirectory(), name);
		return file;
	}
	public static final boolean saveTextToFile_promptUser( final GuiConsole guiConsole, final String text ) {
		final File file = promptUserForSaveFile( guiConsole );
		if( file == null ) {
			return false;
		}
		return saveTextToFile( guiConsole, text, file );
	}
	/**
	 * Save edits to a file
	 * @return true iff successful
	 */
	public static final boolean saveTextToFile( final GuiConsole guiConsole, final String text, final File file ) {
		try {
			BufferedWriter writer=new BufferedWriter(new FileWriter(file));
			try {
				BufferedReader reader = new BufferedReader(new StringReader(text));
				while (true) {
					final String string = reader.readLine();
					if (string == null)
						break;
					writer.write(string);
					writer.newLine();
				}
				reader.close();
			}
			finally {
				writer.close();
			}
		}
		catch (IOException e) {
			guiConsole.putLine("Error saving file: " + e.toString());
			return false;
		}
//:Fri Jan 13 19:51:49 CST 2006
//:Have the title be the fileName
		guiConsole.getJFrame().setTitle( file.getName() );
		return true;
	}
//:***********************
//:get text from file
	public static final File promptUserForOpenFile( final GuiConsole guiConsole ) {
		final FileDialog fileDialog = new FileDialog(guiConsole.getJFrame(), "Open File");
		fileDialog.setLocationRelativeTo(guiConsole.getJFrame());
		fileDialog.show();
		fileDialog.toFront();
		final String fileName = fileDialog.getFile();
		if( fileName == null ) {
			return null;
		}
		final File file = new File(fileDialog.getDirectory(), fileName);
		return file;
	}
	public static final String getTextFromFile_promptUser( final GuiConsole guiConsole ) throws IOException {
		final File file = promptUserForOpenFile( guiConsole );
		if( file == null ) {
			return "";
		}
		return getTextFromFile( guiConsole, file );
	}
	public static final String getTextFromFile( final GuiConsole guiConsole, final File file ) throws IOException {
		final StringBuffer buffer = new StringBuffer();
		//try {
			// *********************************************
			final BufferedReader reader=new BufferedReader(new FileReader(file));
			String line = null;
			while( null != (line = reader.readLine()) ) {
				buffer.append(line).append( "\n" );
			}
			reader.close();
		//}
		//catch (IOException e) {
		//	guiConsole.putLine("Couldn't read file: " + e.toString());
		//}
		return buffer.toString();
	}
	
	public static final String getTextFromResourcePath(final String resourcePath) {
		
		URL url = LogoAid.class.getResource(resourcePath);
		
		
		try (InputStream istream = url.openStream()) {
			BufferedReader reader = new BufferedReader(new InputStreamReader(istream));
			return reader.lines().collect(Collectors.joining(System.lineSeparator()));
		} catch (IOException ex) {
			System.out.println("resourcePath was: " + resourcePath+"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-177");
			System.out.println("url was: " +url +"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-178");
			System.out.println("io exception: " + ex+"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-179");
			return null;
		}
	}
	//: load prompt
	// filter can be null
	public static final File promptUserForFile(GuiConsole guiConsole, String title, FilenameFilter filter) {
		final FileDialog fileDialog = new FileDialog(guiConsole.getJFrame(), title);
		if (filter != null) {
			fileDialog.setFilenameFilter(filter);
		}
		fileDialog.setLocationRelativeTo(guiConsole.getJFrame());
		fileDialog.show();
		fileDialog.toFront();
		final String fileName = fileDialog.getFile();
		if( fileName == null ) {
			return null;
		}
		final File file = new File(fileDialog.getDirectory(), fileName);
		return file;
	}
//: GET IMAGE FROM .ZIP OR .JAR
	public static Image loadImageFromJarFilePath( final File jarFilePath, final String zipEntryName ) {
	try {
			final ZipFile zipFile = new ZipFile( jarFilePath.getPath() );
			// TRY TO PULL OUT JUST WHAT WE WANT!
			final ZipEntry zipEntry = zipFile.getEntry( zipEntryName );
			
			final InputStream istream = zipFile.getInputStream( zipEntry );
			
			final int size = (int)zipEntry.getSize();
			
			final byte[] bytes = new byte[ (int)size ];
			int rb = 0;
			int chunk = 0;
			while( ((int)size - rb) > 0 ) {
				chunk = istream.read( bytes, rb, (int)size - rb );
				if( chunk == -1 ) {
					break;
				}
				rb += chunk;
			}
			return java.awt.Toolkit.getDefaultToolkit().createImage( bytes );
		}
		catch( Exception e ) {
			e.printStackTrace();
			System.out.println("EXCEPTION : " + e +"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-225");
		}
		return null;
	}
//: GET IMAGE FROM applicatio .ZIP OR .JAR
	public static Image loadImageFromResource( final String resourceName ) {
		try {
			final ClassLoader cl = Thread.currentThread().getContextClassLoader();
			final URL imageUrl = cl.getResource(resourceName);
			final Image image = ImageIO.read(imageUrl);
			return image;
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("EXCEPTION : " + e +"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-238");
		}
		return null;
	}
	public static Image loadImageFromFile(File file) {
		try {
			if (file != null) {
				return ImageIO.read(file);
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("EXCEPTION : " + e +"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-249");
		}
		return null;
	}
	//: ensure Image is a RenderedImage
	public static RenderedImage ensureRenderedImage(Image image) {
		if (image instanceof RenderedImage renderedImage) {
			return renderedImage;
		}
		
		BufferedImage bufferedImage = new BufferedImage(image.getWidth(null), image.getHeight(null), BufferedImage.TYPE_INT_ARGB);
		
		final Graphics2D g = bufferedImage.createGraphics();
		g.drawImage(image, 0, 0, null);
		g.dispose();
		
		return bufferedImage;
	}
//: GET TEXT FROM .ZIP OR .JAR
	public static String loadTextFromJarFile( final File jarFile, final String zipEntryName ) {
		//printZipContents(jarFile);
		try {
			final ZipFile zipFile = new ZipFile( jarFile.getPath() );
			// TRY TO PULL OUT JUST WHAT WE WANT!
			
			final ZipEntry zipEntry = zipFile.getEntry( zipEntryName );
			
			
			
			
			final InputStream istream = zipFile.getInputStream( zipEntry );
			final BufferedReader bf = new BufferedReader( new InputStreamReader( istream ) );
			
			final StringBuffer buffer = new StringBuffer();
			String line = null;
			while( (line = bf.readLine()) != null ) {
				buffer.append( line + "\n");
			}
			
			bf.close();
			final String s = buffer.toString();
			
			
			return s;
		}
		catch( Exception e ) {
			e.printStackTrace();
			System.out.println("EXCEPTION : " + e +"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-296");
		}
		return null;
	}
	public static void showTextInFrame(String text ) {
		showTextInFrame(text,true);
	}
	public static void showTextInFrame(String text, final boolean closeable) {
		// ===================================================================
		JFrame frame = new JFrame();
		frame.getContentPane().setLayout(new BorderLayout());
		JTextArea textArea = new JTextArea();
		
		final java.awt.Insets insets = new java.awt.Insets(20,20,20,20);
		textArea.setMargin(insets);
		
		textArea.setLineWrap(true);
		//textArea.setFont( GuiConsole._monofont );
		textArea.setText( text );
		JScrollPane scroller = new JScrollPane( textArea  );
		frame.getContentPane().add( scroller, BorderLayout.CENTER );
		frame.pack();
		frame.setSize( new Dimension( 725, 525 ) );
		frame.setLocationRelativeTo(null);
		frame.setVisible(true);
		frame.getContentPane().doLayout();
		frame.toFront();
		//frame.setLocation(frame.getLocation().x + 35, frame.getLocation().y + 35 );
		
		
		// DO NOT CLOSE WINDOW
		if(!closeable) {
			frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		}
		// ===================================================================
	}
	
	public static void printZipContents(final File zipFile) {
		System.out.println("printZipContents: " + zipFile+"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-334");
		try {
			final ZipFile zf = new ZipFile(zipFile.getPath());
			
			for( Enumeration e = zf.entries(); e.hasMoreElements(); ) {
				final ZipEntry ze = (ZipEntry)e.nextElement();
				System.out.println("zipEntry: " + ze+"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-340");
				final String entryName = ze.toString().trim();
				System.out.println("zipEntry name: " + entryName+"<:|:>"+"virtuoso.logo.app.LogoAid.java.ux:TL-342");
			}
		} catch (Throwable t) {
			System.out.println("Error parsing zip file: " + t);
		}
	}
	
}