
/* ***************************************************
	FILE:  PasswordUI.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;


// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**
	The panel that shows a message and asks for a password...
	
	
*/
public class PasswordUI extends JPanel
{
	public static final String aquirePasswordFromUser(final JFrame parent, final String message) {
		
		// MAKE THE LABEL
		final JLabel label = new JLabel( message );
		
		// MAKE THE PASSWORD FIELD
		final JPasswordField field = new JPasswordField();
		field.setEchoChar( '*' );
		
		// COMBINE THEM IN A PANEL
		final JPanel p = new JPanel();
		p.setLayout( new GridLayout( 2, 1 ) );
		p.add( label );
		p.add( field );
		
		// MAKE THE BUTTONS
		final JButton okButton = new JButton("Ok");
		final JButton cancelButton = new JButton("Cancel");
		final JPanel buttons = new JPanel();
		buttons.setLayout( new FlowLayout( FlowLayout.RIGHT));
		buttons.add( cancelButton );
		buttons.add( okButton );
		
		
		
		final JPanel outer = new JPanel();
		outer.setLayout( new BorderLayout());
		outer.add( p, BorderLayout.CENTER );
		outer.add( buttons, BorderLayout.SOUTH);
		
		
		
		final boolean modal = true;
		final JDialog dialog = new JDialog(parent,modal);
		dialog.getContentPane().add( outer );
		
		
		// LINK IN THE BUTTON LISTENERS
		okButton.addActionListener(new ActionListener() {public void actionPerformed(ActionEvent event){
			dialog.setVisible(false);
		}} );
		cancelButton.addActionListener(new ActionListener() {public void actionPerformed(ActionEvent event){
			field.setText("");
			dialog.setVisible(false);
		}} );
		
		//dialog.setSize( 300, 100 );
		dialog.pack();
		
		dialog.setLocationRelativeTo(null);
		
		// THIS BLOCKS UNTIL THEY HIT OK....
		dialog.setVisible(true);
		
		// 
		
		final char[] password = field.getPassword();
		
		return new String( password );
	}
	
	
}