
/* ***************************************************
	FILE:  SimpleSingleImageWindow.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

/**
	A simple window to display a single image.
*/
public class SimpleSingleImageWindow extends JFrame
{
	private Image _image;
	
	/**
		
	*/
	public SimpleSingleImageWindow(Image image, String title) {
		this._image = image;
		
		setTitle(title);
		
		getContentPane().setLayout(new BorderLayout());
		
		// Load the image, for width and height?
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(_image,0);
		try {
			mt.waitForID(0);
		} catch(InterruptedException ie){}
		
		// Center the window on the screen
		int imgWidth = _image.getWidth(this);
		int imgHeight = _image.getHeight(this);
		//setSize(imgWidth, imgHeight);
		Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation( (screenDim.width - imgWidth) / 2, (screenDim.height - imgHeight) / 2 );
		
		try {
			JLabel imageLabel = new JLabel(new ImageIcon(image));
			getContentPane().add(imageLabel, BorderLayout.CENTER);
			pack();
		} catch (Exception ex) {
			ex.printStackTrace();
			System.out.println("exception : " + ex+"<:|:>"+"virtuoso.logo.app.SimpleSingleImageWindow.java.ux:TL-86");
		}
	}
	
}