
/* ***************************************************
	FILE:  UIAid.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**

*/
public class UIAid
{
	public static final Font SMALL_FONT = new Font( "Andale Mono", Font.PLAIN, 10 );
	public static final Font LARGE_FONT_BOLD = new Font( "Monospaced", Font.BOLD, 18 );
	public static final Font STANDARD_FONT_BOLD = new Font( "Monospaced", Font.BOLD, 14 );
	public static final Font SMALL_FONT_BOLD = new Font( "Monospaced", Font.BOLD, 12 );
	public static final Color LABEL_TEXT_COLOR = new Color( 59, 51, 60 );
	
	
	public static void borderize(final JComponent comp,final String title){
		if( comp == null ) {
			return;
		}
		final TitledBorder border = new TitledBorder( title );
		border.setTitleFont( SMALL_FONT_BOLD );
		border.setTitleColor( LABEL_TEXT_COLOR );
		comp.setBorder( border );
	}
	
	public final static int BSIZE = 22;
	// SHOW_IMAGE 100 "app-images" "images/turtletracksimages/stop-tiny.jpg"
	public static JButton makeStopButton( final GuiConsole guiConsole, final ActionListener actionListener ) {
		final Image image = LogoAid.loadImageFromResource( "images/stop-tiny.jpg" );
		final ImageIcon icon = new ImageIcon( image );
		JButton button = new JButton( icon );
		button.addActionListener( actionListener );
		button.setPreferredSize( new Dimension( BSIZE, BSIZE ) );
		button.setMaximumSize( new Dimension( BSIZE, BSIZE ) );
		button.setToolTipText("Stop Button.");
		return button;
	}
	// SHOW_IMAGE 100 "app-images" "images/turtletracksimages/go-tiny.jpg"
	public static JButton makeGoButton( final GuiConsole guiConsole, final ActionListener actionListener ) {
		final Image image = LogoAid.loadImageFromResource( "images/go-tiny.jpg" );
		final ImageIcon icon = new ImageIcon( image );
		JButton button = new JButton( icon );
		button.setPreferredSize( new Dimension( BSIZE, BSIZE ) );
		button.setMaximumSize( new Dimension( BSIZE, BSIZE ) );
		button.addActionListener( actionListener );
		button.setToolTipText("Go Button.");
		return button;
	}
	
	// SHOW_IMAGE  100 "app-images" "images/turtletracksimages/defined.jpg"
	public static final Image get_defined_image() {
		final Image image = LogoAid.loadImageFromResource( "images/defined.jpg" );
		return image;
	}
	public static final Image DEFINED_IMAGE = get_defined_image();
	public static final int DEFINED_IMAGE_WIDTH = 63; // HARD CODED FROM PAINT TOOL INSPECTION
	
	
	// SHOW_IMAGE  100 "app-images" "images/turtletracksimages/undefined.jpg"
	public static final Image get_undefined_image() {
		final Image image = LogoAid.loadImageFromResource( "images/undefined.jpg" );
		return image;
	}
	public static final Image UNDEFINED_IMAGE = get_undefined_image();
	
	// SHOW_IMAGE  200 "app-images" "images/turtletracksimages/lock.jpg"
	
	public static final Image get_lock_image() {
		final Image image = LogoAid.loadImageFromResource(  "images/lock.jpg" );
		return image;
	}
	public static final Image LOCK_IMAGE = get_lock_image();
	
	// SHOW_IMAGE  50 "app-images" "images/turtletracksimages/splash.jpg"
	public static final Image get_splash_image() {
		final Image image = LogoAid.loadImageFromResource( "images/splash.png" );
		return image;
	}
	public static final Image SPLASH_IMAGE = get_splash_image();
	
	
	public static final Image get_turtle_image() {
		final Image image = LogoAid.loadImageFromResource( "images/Turtle_button01.png" );
		return image;
	}
	public static final Image TURTLE_IMAGE = get_turtle_image();
	
}