
/* ***************************************************
	FILE:  View_PDF.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import org.icepdf.ri.common.MyAnnotationCallback;
import org.icepdf.ri.common.SwingController;
import org.icepdf.ri.common.SwingViewBuilder;
import org.icepdf.ri.util.PropertiesManager;

import javax.swing.*;
import java.awt.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.ResourceBundle;

/**
	
	
*/
public class View_PDF extends JPanel
{
	SwingController controller;
	SwingViewBuilder factory;
	
	Container vpanel;

	public View_PDF(final String resourcePath) {
	
		// hack: https://www.icesoft.org/JForum/posts/list/23354.page
		Properties myProperties = new Properties();
		myProperties.setProperty("application.showLocalStorageDialogs", "false");
		// hack: https://www.icesoft.org/JForum/posts/list/21752.page
		myProperties.setProperty(PropertiesManager.PROPERTY_DEFAULT_PAGEFIT,"3" );
		
		//: https://www.icesoft.org/wiki/display/PDF/Customizing+the+Viewer
		PropertiesManager properties = new PropertiesManager(System.getProperties(), myProperties, ResourceBundle.getBundle(PropertiesManager.DEFAULT_MESSAGE_BUNDLE));
		
		
		
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_FIT, false);
		
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_UTILITY, false);
		//properties.setBoolean(PropertiesManager.PROPERTY_SHOW_UTILITY_SAVE, false);
		//properties.setBoolean(PropertiesManager.PROPERTY_SHOW_UTILITY_SEARCH, false);
		//properties.setBoolean(PropertiesManager.PROPERTY_SHOW_UTILITY_UPANE, false);
		
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_ROTATE, false);
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_ANNOTATION, false);
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_ZOOM, false);
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_TOOL, false);
		properties.setBoolean(PropertiesManager.PROPERTY_SHOW_TOOLBAR_FORMS, false);
		//properties.setBoolean(PropertiesManager.PROPERTY_VIEWPREF_FORM_HIGHLIGHT, false);
		//PROPERTY_SHOW_TOOLBAR_ANNOTATION_HIGHLIGHT

			
		controller = new SwingController();
		factory = new SwingViewBuilder(controller, properties);
		
		setLayout(new BorderLayout());
		vpanel = factory.buildViewerPanel();
		add(vpanel, BorderLayout.CENTER);
		
		//SwingUtilities.invokeLater( {
			try {
				URL url = this.getClass().getResource(resourcePath);
				
				
				if( url != null ) {
					controller.openDocument(url);
				}
			} catch(Exception ex) {
				ex.printStackTrace();
				System.out.println( " exception " +ex ); 
			}
		//} as Runnable );
		
		simplifyView( vpanel );
	}
	
	public void simplifyView( final Container pdfView ) {
	 //: this seems to be a hack to allow for the View_PDF to function in a JFrame with scrolling
		final Component keep_1 = pdfView.getComponents()[1];
		final Component keep_2 = pdfView.getComponents()[1];
		
		final Container a = (Container)pdfView.getComponents()[2];
		final Container b = (Container)a.getComponents()[1];
		final JToggleButton button = (JToggleButton)b.getComponents()[1];
		button.doClick( 20 );
		
		//pdfView.remove( pdfView.getComponents()[0] );
		//pdfView.add( keep_1, BorderLayout.CENTER );
		//pdfView.add( keep_2, BorderLayout.SOUTH );
	}


}