
/* ***************************************************
	FILE:  WindowHandler.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**
	Inner class for handling window events
	
	Sun Jul 10 17:41:15 CDT 2005,
		pulled this out of the GuiConsole class
 */
class WindowHandler
extends WindowAdapter
{
	public WindowHandler( final GuiConsole console ) {
		_guiConsole = console;
	}
	private GuiConsole _guiConsole;

	/**
	 * Handle window closing events
	 * @param event the event
	 */
	public void windowClosing( final WindowEvent event ) {
		Window w = event.getWindow();
		
		if( w instanceof GuiConsoleWind ) {
			final int result = MessageWind.execute(MessageWind.genStrings("Are you sure you want to quit PowerMath Logo?"),MessageWind.genStrings("Quit", "Cancel"), (Frame)w);
			if( result == 0 ) {
				_guiConsole.goodbye();
				_guiConsole.mach().terminateAllThreads();
				_guiConsole.pushBuffer( new String() );
			} else {
				//event.consume();
			}
		}
		/*
		else if( w instanceof GuiEditorWind ) {
			GuiEditorWind wind = (GuiEditorWind)w;
			int result = MessageWind.execute(MessageWind.genStrings("Do you want to execute or save your edits before closing?"),MessageWind.genStrings("Execute", "Save To File", "Discard", "Cancel"), wind);
			if (result == 0){
				wind.getGuiEditorPanel().acceptEdits();
			}
			else if (result == 1){
				if (!wind.getGuiEditorPanel().saveToFile())
					return;
			}
			if( result != 3 ) {
				_guiConsole._editors.removeElement(wind);
				wind.dispose();
			}
		}
		*/
	}
}