
/* ***************************************************
	FILE:  StopAction.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app.actions;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

public class StopAction
{
	/**
		
	*/
	public void execute() {
		getGuiConsole().mach().terminateAllThreads();
		
		
		getGuiConsole().getConsolePanel().requestFocus();
		
		// make sure pen is down
		getGuiConsole().getTurtlePrimitives().pPENDOWN_IMP();
		// make sure refresh is 0
		getGuiConsole().getTurtlePanel().setRedisplayInterval( 0 );
		getGuiConsole()._turtleDisplayThread.setInterval(getGuiConsole().getTurtlePanel().getRedisplayInterval());
		
		try {
			Thread.currentThread().wait(20);
		} catch( Exception exception ) {
			//...
		}
		
		if( getShouldPrintMessage() ) {
			getGuiConsole().putStatusMessage( "PROCEDURE STOPPED!" );
			// ==========================
			// Wed Sep 07 13:04:27 CDT 2005
			// need this to get prompt back up so that user don't have to 'enter things twice' after a stop
			getGuiConsole().pushBuffer( "" );
			// ==========================
		}
	
		if( getShouldClearScreen() ) {
			// CLEAR THE TURTLE GRAPHICS AREA
			//getGuiConsole().pushBuffer( "CLEARSCREEN" );
			try {
				getGuiConsole().getTurtlePrimitives().clearScreenIMP();
			} catch( Exception e ) {
				getGuiConsole().putLine( "FAILED TO CLEAR TURTLE GRAPHICS AREA " + e.toString() );
			}
		}
	}
	public StopAction( final GuiConsole guiConsole ) {
		setGuiConsole( guiConsole );
	}
	
	//:GuiConsole
		public final GuiConsole getGuiConsole(){return _GuiConsole;}
		public final StopAction setGuiConsole(final GuiConsole aGuiConsole){
			
			_GuiConsole=aGuiConsole;
			
			return this;
		}
		private GuiConsole _GuiConsole;
	
	//:ShouldClearScreen
		public final boolean getShouldClearScreen(){return _ShouldClearScreen;}
		public final StopAction setShouldClearScreen(final boolean aShouldClearScreen){
			
			_ShouldClearScreen=aShouldClearScreen;
			
			return this;
		}
		private boolean _ShouldClearScreen;
	
	//:ShouldPrintMessage
		public final boolean getShouldPrintMessage(){return _ShouldPrintMessage;}
		public final StopAction setShouldPrintMessage(final boolean aShouldPrintMessage){
			
			_ShouldPrintMessage=aShouldPrintMessage;
			
			return this;
		}
		private boolean _ShouldPrintMessage;
	
}