
/* ***************************************************
	FILE:  LogoFileHeader.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.file;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**
	The meta information of a .logo file.
*/
public class LogoFileHeader
{
	protected final static String HEADER_LINE_PREFIX = "<<<<<<<<<<<<<<<HEADER_LINE_PREFIX:";
	protected final static String FILE_LOCKED = "logofile_locked";
	protected final static String FILE_UNLOCKED = "logofile_unlocked";
	
	
	protected void removeLock() {
		final StringBuffer buffer = new StringBuffer();
		final String lockLine = getHeaderLineWithToken( FILE_LOCKED );
		
		final StringTokenizer tokenizer = new StringTokenizer(getText(),"\n");
		while( tokenizer.hasMoreElements() ) {
			final String line = tokenizer.nextToken();
			if( !line.equals( lockLine ) ) {
				buffer.append( line + "\n" );
			}
		}
		setText( buffer.toString() );
	}
	protected void addLock() {
		setText( getText() + HEADER_LINE_PREFIX + FILE_LOCKED + "\n" );
	}
	
	private String getHeaderLineWithToken( final String token ) {
		final StringTokenizer tokenizer = new StringTokenizer(getText(),"\n");
		while( tokenizer.hasMoreElements() ) {
			final String line = tokenizer.nextToken();
			if( line.indexOf( token ) != -1 ) {
				return line;
			}
		}
		return null;
	}
	protected boolean isLocked() {
		final String headerLine = getHeaderLineWithToken( FILE_LOCKED );
		if( headerLine != null ) {
			return true;
		}
		return false;
	}
	/**
		Return the text portion of the file that represents logo procedures.
	*/
	protected String getText() {
		return _text;
	}
	protected void setText( final String text ) { _text = text; }
	private String _text = "";
	
}