
/* ***************************************************
	FILE:  TurtleTilesPanel.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.lib;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**
	Mon Jul 25 23:51:55 CDT 2005
		made this to allow for viewing of 'tiled' turtle panels,
		for use in desktop background picture development
		(used to have to go into photoshop and crop a screen capture
		and actually place the file into the desktop for viewing)
*/
public final class TurtleTilesPanel extends JPanel
{
	int _redisplayInterval;
	
	public void setImageToTile( final Image image ) {
		_tiledImage = image;
	}
	private Image _tiledImage;
	
	public TurtleTilesPanel() {
		
	}
	public void paint( Graphics g) {
		final int width = getWidth();
		final int height = getHeight();
		
		final Image image = _tiledImage;
		final int iw = image.getWidth( this );
		final int ih = image.getHeight( this );
		
		
		// Tue Jul 26 18:02:25 CDT 2005
		// there is a bug, i think since zero row never has lines drawn in it,
		// that bug is in TurtlePanel i suppose but for now we compensate here.
		for( int x = 0; x < width; x += iw ) {
			for( int y = 0; y < height; y += ih ) {
				g.drawImage( _tiledImage, x, y, this );
			}
		}
		
	}
	
	// -------------------------------------------
	public static final void showInFrameWithThread( final TurtlePanel tp ) {
		final TurtleTilesPanel tiles = new TurtleTilesPanel();
		tiles.setImageToTile( tp.getOffscreenImage() );
		
		JFrame frame = new JFrame();
		frame.getContentPane().setLayout( new BorderLayout() );
		
		frame.getContentPane().add( tiles, BorderLayout.CENTER );
		
		frame.setSize( 800, 800 );
		frame.setLocationRelativeTo(null);
		frame.setVisible( true );
		
		final Thread t = new Thread() {
			public void run() {
				while( true ) {
					tiles.repaint();
				
					try {
						sleep( 300 );
					}
					catch( Throwable t ) {
						System.out.println("throwable : " + t +"<:|:>"+"virtuoso.logo.lib.TurtleTilesPanel.java.ux:TL-127");
						break;
					}
				}
			}
		};
		t.start();
		
		// could here add a window listener if i really cared to...(but why in world should i?)
	}
}