
/* ***************************************************
	FILE:  Startups.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.startups;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**
*/
public class Startups
{
	public static String getStartupProceduresText() {
		if(_startupProceduresText==null){
			loadInitialTexts();
		}
		// MAKE IT SO ONLY ONE ATTEMPT
		if(_startupProceduresText==null){
			_startupProceduresText = "";
		}
		return _startupProceduresText;
	}
	private static String _startupProceduresText=null;
	
	public static String getStartupCommandCenterText() {
		if(_startupCCenterText==null){
			loadInitialTexts();
		}
		// MAKE IT SO ONLY ONE ATTEMPT
		if(_startupCCenterText==null){
			_startupCCenterText = "";
		}
		return _startupCCenterText;
	}
	private static String _startupCCenterText=null;

	public static String getAvailableProceduresText() {
		if(_availableProceduresText==null){
			loadInitialTexts();
		}
		// MAKE IT SO ONLY ONE ATTEMPT
		if(_availableProceduresText==null){
			_availableProceduresText = "";
		}
		return _availableProceduresText;
	}
	private static String _availableProceduresText=null;

	
	public static String getStandaloneTutorialText() {
		if(_standaloneTutorialText==null){
			loadInitialTexts();
		}
		// MAKE IT SO ONLY ONE ATTEMPT
		if(_standaloneTutorialText==null){
			_standaloneTutorialText = "";
		}
		return _standaloneTutorialText;
	}
	private static String _standaloneTutorialText=null;
	
	/**
		may return null, in which case the user can fall back on attempting to get the text from the .txt or .jar stuff with the getStandaloneTutorialText().
	*/
	public static File getTutorialRTF() {
		final File tutorialFileRTF = new File( System.getProperty( "user.dir" ) + File.separator + "tutorial.rtf" );
		if( tutorialFileRTF.exists() ) {
			return tutorialFileRTF;
		}
		return null;
	}
	/**
		may return null, in which case the user can fall back on attempting to get the text from the .txt or .jar stuff with the getStandaloneTutorialText().
	*/
	public static File getTutorialPDF() {
		final File tutorialFile_pdf = new File( System.getProperty( "user.dir" ) + File.separator + "tutorial.pdf" );
		if( tutorialFile_pdf.exists() ) {
			return tutorialFile_pdf;
		}
		return null;
	}

	/**
	
	*/
	private static void loadInitialTexts() {
		final File tutorialFile = new File( System.getProperty( "user.dir" ) + File.separator + "tutorial.txt" );
		if( tutorialFile.exists() ) {
			try {
				_standaloneTutorialText = LogoAid.getTextFromFile( null, tutorialFile );
			}catch(Exception e){
				// ahh shucks
			}
		}
		
		try {
			final File zipFile = new File( System.getProperty( "user.dir" ) + File.separator + "XM" );
			final ZipFile zf = new ZipFile( zipFile.getPath() );
		
			for( Enumeration e = zf.entries(); e.hasMoreElements(); ) {
				final ZipEntry ze = (ZipEntry)e.nextElement();
				final String entryName=ze.toString().trim();
				String Ne = entryName;
				// chop off the "XM/"
				Ne=Ne.substring(3,Ne.length());
				if( !ze.isDirectory() ) {
					if( Ne.equalsIgnoreCase("startup.commandcenter.txt") ) {
						_startupCCenterText = (""+LogoAid.loadTextFromJarFile( zipFile, entryName)).trim();
					} else if( Ne.equalsIgnoreCase( "startup.procedures.txt" ) ) {
						_startupProceduresText = (""+LogoAid.loadTextFromJarFile( zipFile, entryName)).trim();
					} else if( Ne.equalsIgnoreCase( "available.procedures.txt" ) ) {
						_availableProceduresText = (""+LogoAid.loadTextFromJarFile( zipFile, entryName)).trim();
					} else if( Ne.equalsIgnoreCase( "standalone.tutorial.window.txt" ) ) {
						
						// only load if the "tutorial.txt" file was not found already
						if( _standaloneTutorialText == null ) {
							//System.out.println("here we load standalone...1");
							_standaloneTutorialText = (""+LogoAid.loadTextFromJarFile( zipFile, entryName)).trim();
							//System.out.println("here we load standalone...2 it was: "+_standaloneTutorialText);
						}
					}
				}
			}
		} catch( Throwable t ) {
			System.out.println("Error parsing XM file: " + t );
		}
	}
}